%global git_commit b362566
%global cluster wmeissner
%define pkg_version 0-g%{git_commit}
%define with_maven 1
Name:          jaffl
Version:       0.5.9
Release:       %mkrel 1
Summary:       Java Abstracted Foreign Function Layer
Group:         Development/Java
License:       LGPLv3
Url:           http://github.com/%{cluster}/%{name}
Source0:       %{url}/tarball/%{version}/%{cluster}-%{name}-%{version}-%{pkg_version}.tar.gz
Patch0:        jaffl-0.5.9-fix_jar_dependencies.patch

# invokedynamic is a Java 7 feature and the method
# which needs it is only defined and not used
Patch1:        jaffl_remove_invokedynamic.patch
Patch2:        jaffl-0.5.9-pom_xml.patch
BuildRequires: java-devel
BuildRequires: jpackage-utils
%if !%with_maven
BuildRequires: ant
BuildRequires: ant-nodeps
%else
BuildRequires: maven
BuildRequires: maven-antrun-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-surefire-provider-junit4
BuildRequires: maven-surefire-plugin
%endif
BuildRequires: jffi
BuildRequires: jnr-x86asm
BuildRequires: objectweb-asm
Requires:      java
Requires:      jpackage-utils
Requires:      jffi
Requires:      jnr-x86asm
Requires:      objectweb-asm
BuildArch:     noarch

%description
An abstracted interface to invoking native functions from java

%package javadoc
Summary:        Javadocs for %{name}
Group:          Development/Java 
Requires:       %{name} = %{version}-%{release}
Requires:       jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n %{cluster}-%{name}-%{git_commit}
%patch0 -p1
%patch2 -p0

# remove all builtin jars
find . -iname '*.jar' -delete
find . -iname '*.class' -delete
find . -iname '*.zip' -delete

# remove tests/junit dependency
rm -rf test/

%if !%with_maven
# remove tests/junit dependency
rm -rf test/

mkdir build_lib
build-jar-repository -s -p build_lib jffi jnr-x86asm objectweb-asm/asm \
                                     objectweb-asm/analysis objectweb-asm/commons \
                                     objectweb-asm/tree objectweb-asm/util objectweb-asm/xml
%endif

%build
%if %with_maven
  export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mvn-rpmbuild \
    install:install-file \
    -DgroupId=org.jruby.extras \
    -DartifactId=jffi \
    -Dversion=1.0.6 \
    -Dclassifier=native \
    -Dpackaging=jar \
    -Dfile=$(build-classpath jffi) \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL

mvn-rpmbuild \
    install:install-file \
    -DgroupId=org.jruby.extras \
    -DartifactId=jffi \
    -Dversion=1.0.6 \
    -Dpackaging=jar \
    -Dfile=$(build-classpath jffi) \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL

mvn-rpmbuild -e \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    install javadoc:javadoc
%else
  ant
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_javadir}
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

%if %with_maven
  install -pm 644 target/jaffl-%{version}.jar %{buildroot}%{_javadir}/
%else
  install -pm 644 dist/%{name}-0.5.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%endif

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}*; do
    ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`
  done
)

%if %with_maven
  cp -rp build/report/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%else
  cp -rp dist/javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

# pom
%add_to_maven_depmap org.jruby.extras %{name} %{version} JPP %{name}
mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml  %{buildroot}%{_mavenpomdir}/JPP-jaffl.pom

# pom
%add_to_maven_depmap org.jruby.extras %{name} %{version} JPP %{name}
mkdir -p $RPM_BUILD_ROOT%{_mavenpomdir}
cp pom.xml  $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-jaffl.pom

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_mavendepmapfragdir}/%{name}
%{_mavenpomdir}/*
%doc LICENSE

%files javadoc
%{_javadocdir}/%{name}
%{_javadocdir}/%{name}-%{version}



%changelog

* Thu Nov 03 2011 dmorgan <dmorgan> 0.5.9-1.mga2
+ Revision: 162569
- Clean spec file
- imported package jaffl

  + gil <gil>
    - update to 0.5.9


* Fri Oct 29 2010 Mohammed Morsi <mmorsi@redhat.com> - 0.5.4-4
- license fix, include pom.xml, install javadocs correctly

* Tue Oct 26 2010 Mohammed Morsi <mmorsi@redhat.com> - 0.5.4-3
- change to patch0 to remove class-path-in-manifest rpmlint error

* Thu Sep 16 2010 Matěj Cepl <mcepl@redhat.com> - 0.5.4-2
- Make the package noarch

* Thu Sep  09 2010  <mmorsi@redhat.com> - 0.5.4-1
- bumped version to 0.5.4
- added jaffl_remove_invokedynamic.patch

* Thu Jan  28 2009  <mmorsi@redhat.com> - 0.3.4-1
- Initial build.
